#pragma once

#include <ReWindow/RWindowImpl.hpp>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <GL/glx.h>
#include "J3ML/LinearAlgebra.hpp"


namespace ReWindow { class XLibImpl; };

class ReWindow::XLibImpl : ReWindow::RWindowImpl {
    Window window;
    XEvent xev;
    Display* display = XOpenDisplay(nullptr);
    int defaultScreen = DefaultScreen(display);
    XVisualInfo* visual;
    XSetWindowAttributes xSetWindowAttributes;
    XWindowAttributes windowAttributes;
    Atom wmDeleteWindow;
    // Make it start as floating because fuck tiling WMs
    Atom windowTypeAtom;
    Atom windowTypeUtilityAtom;
    XSizeHints hints;
    GLXContext glContext;
    Cursor invisible_cursor = 0;
    Vector2 render_area_position = {0, 0};
    Vector2 position = {0, 0};
    bool should_poll_x_for_mouse_pos = true;
public:
    void Open() override;
    void Close() override;
    void PollEvents() override;
    void SetTitle(const std::string &title) override;
    void Refresh() override;
};

